	Title  "PicNPoke FSR Program"

	list p=16f84        ; processor type

	include "P16f84.inc"

;
; The purpose of this program is to explain the FSR and Indirect Addressing
;
;
; -------------
; PROGRAM START
; -------------
;
	org 0h			; startup address = 0000


          clrf EEADR          ; set first EEPROM address
EepLoop   movf PORTB,W        ; get data from PORTB
          call EepWrite       ; write the data
          incf EEADR          ; next address location
          movlw d'64'         ; test if written to all
          xorwf EEADR,W
          btfss STATUS,Z
          goto EepLoop        ; no

          clrf EEADR	; set for first address
EEloop    call EepRead	; get the data
          movwf PORTB	; send to PORTB
          incf EEADR	; set for next address
          movlw d'64'	; test for last address
          xorwf EEADR,W
          btfss STATUS,Z
          goto EEloop	; not last
	
StayHere	goto StayHere       ; all done

;
; SUBROUTINE: READ FROM EEPROM
; On entry, W = address to read from
; On exit, W = data that was read
;
EepRead   bcf STATUS,RP0         ; RAM Page 0
          movwf EEADR
          bsf STATUS,RP0         ; RAM Page 1
          bsf EECON1,RD          ; read the data
          bcf STATUS,RP0         ; RAM Page 0
          movf EEDATA,W
          return
;
; SUBROUTINE: WRITE TO EEPROM
; On entry, W = data to be written
; and EEADR is already set
;
EepWrite  movwf EEDATA
          bsf STATUS,RP0      ; RAM Page 1
          bsf EECON1,WREN     ; enable EEPROM writes
          movlw 0x55          ; begin writing
          movwf EECON2
          movlw 0xAA
          movwf EECON2
          bsf EECON1,WR
WriteWait btfsc EECON1,WR     ; wait for write completion
          goto WriteWait

          bcf STATUS,RP0      ; RAM Page 0
          return

	end
