		Title  "PicNPoke Flash Program"

		list p=16f84 			; processor type
;
; The purpose of this program is to make a LED turn on and off
; The LED is connected to PortA, open collector pin RA4
; The flash rate is 500mS
;
PortA		equ 0x05		; PortA RAM address
LED		equ 0x04		; PortA RA4 = bit 4 for LED
TrisA		equ 0x85		; TRISA RAM address
TrisB		equ 0x86		; TRISB RAM address
Status		equ 0x03		; Status RAM address
RP0		equ 0x05		; Status RP0 bit = bit 5
DelayL		equ 0x0C		; delay register LOW byte
DelayM		equ 0x0D		; delay register MID byte
DelayH		equ 0x0E		; delay register HIGH byte
; 
; -------------
; PROGRAM START
; -------------
;
		org 0h			; startup address = 0000

		bsf Status,RP0		; set RP0 for RAM page 1
		clrf TrisA		; all PortA = outputs
		clrf TrisB		; all PortB = outputs
		bcf Status,RP0		; set RP0 for RAM page 0

start		bcf PortA,LED		; turn on LED on RA4
		call Delay500		; execute a 500mS delay

		bsf PortA,LED		; turn off LED on RA4
		call Delay500		; execute a 500mS delay

		goto start		; do this loop forever
;
; --------------------------------
; SUBROUTINE: waste time for 500mS
; --------------------------------
;
Delay500	clrf DelayL		; /R clear DelayL to 0
		clrf DelayM		; clear DelayM to 0
		movlw 3h		; set DelayH to 3
		movwf DelayH
Wait1		decfsz DelayL		; subtract 1 from DelayL
		goto Wait1		; if not 0, goto Wait1
		decfsz DelayM		; subtract 1 from DelayM
		goto Wait1		; if not 0, goto Wait1
		decfsz DelayH		; subtract 1 from DelayH
		goto Wait1		; if not 0, goto Wait1
		return			; finished the delay

		end
