		Title  "PicNPoke Multiplexed 7 Segment Program A"

		list p=16F84 		; processor type
;
; This program is used to multiplex two 7 segment displays
; The display segments are connected to PortB
; Display A is controlled by PortA RA0
; Display B is controlled by PortA RA1
;
; The program shows the number '1' and '2' on the displays
;
PortA	equ 0x05		; /WB PortA RAM address
PortB	equ 0x06		; /WB PortB RAM address
TrisA	equ 0x85		; TRISA RAM address
TrisB	equ 0x86		; TRISB RAM address
Status	equ 0x03		; Status RAM address
RP0	equ 0x05		; Status RP0 bit = bit 5
DispA	equ 0x00		; Display A = RA0
DispB	equ 0x01		; Display B = RA1
; 
; -------------
; PROGRAM START
; -------------
;
	org 0h		; startup address = 0000h

	clrf PortA	; make sure all displays are off
	clrf PortB	; make sure all segments are off
	bsf Status,RP0	; set RP0 for RAM page 1
	clrf TrisA	; all PortA = outputs
	clrf TrisB	; all PortB = outputs
	bcf Status,RP0	; set RP0 for RAM page 0

Loop1	movlw b'00000110'	; segment data for displaying digit '1'
          movwf PortB	; send it to PortB
	bsf PortA,DispA	; (0) turn display A on
          nop           
          nop           
          bcf PortA,DispA	; (0) turn display A off
          movlw b'01011011'	; segment data for displaying digit '2'
          movwf PortB	; send it to PortB
	bsf PortA,DispB	; (1) turn display B on
          nop           
          nop           
          bcf PortA,DispB	; (1) turn display B off
          goto Loop1	; continue and repeat


	end

