		Title  "PicNPoke Tables at the Boundary"

		list p=16f84 		; processor type

		include "P16f84.inc"
;
; This program is used to show the errors that occur if the
; PCLATH is not set properly when changing the PCL register.
;
	CBLOCK 0x20

Pointer		; display data pointer

	ENDC
; 
; -------------
; PROGRAM START
; -------------
;
	org 0h			; startup address = 0000

	bsf STATUS,RP0		; set RP0 for RAM page 1
	clrf TRISA		; all PortA = outputs
	clrf TRISB		; all PortB = outputs
	bcf STATUS,RP0		; set RP0 for RAM page 0

Loop1	clrf Pointer		; reset the pointer to 0
Loop2	movf Pointer,w		; put Pointer into W
	call DataTable          	; put digit value in W
	movwf PORTB		; now display new digit
	incf Pointer		; add 1 to Pointer value
	movlw d'10'		; see if Pointer = 10
	xorwf Pointer,w		; if it is, reset it to 0
	btfss STATUS,Z		; test Zero bit		
	goto Loop2		; Z = 0, do Loop 2
	goto Loop1		; Z = 1, do Loop 1

	org 0x00F9

;
; -----------------------------------------
; SUBROUTINE: lookup table for display data
; -----------------------------------------
; Bit 0 = RB0 = segment A
; Bit 1 = RB1 = segment B
; Bit 2 = RB2 = segment C
; Bit 3 = RB3 = segment D
; Bit 4 = RB4 = segment E
; Bit 5 = RB5 = segment F
; Bit 6 = RB6 = segment G
; Bit 7 = RB7 = Decimal Point
;
DataTable	addwf PCL			; add W value to PCL
	retlw b'00111111'		; 0
	retlw b'00000110'		; 1
	retlw b'01011011'		; 2    
	retlw b'01001111'		; 3   
	retlw b'01100110'		; 4   
	retlw b'01101101'		; 5   
	retlw b'01111101'		; 6   
	retlw b'00000111'		; 7   
	retlw b'01111111'		; 8   
	retlw b'01101111'		; 9   


	end
