	Title  "PicNPoke Relay Program"

             list p=16f84        ; processor type
;
; The purpose of this program is to make a RELAY turn on and off
; The RELAY is connected to PortA pin RA0
; The operate rate is 500mS
;
PortA        equ 0x05           ; PortA RAM address
RELAY        equ 0x00           ; PortA RA0 = bit 0 for RELAY
TrisA        equ 0x85           ; TRISA RAM address
TrisB        equ 0x86           ; TRISB RAM address
Status       equ 0x03           ; Status RAM address
RP0          equ 0x05           ; Status RP0 bit = bit 5
PIR1         equ 0x0C           ; PIR1 register
RCIF         equ 0x05           ; RCIF flag bit
RCREG        equ 0x1A           ; RS232 receive register
PCLATH       equ 0x0A           ; PCLATH register
DelayL       equ 0x20           ; delay register LOW byte
DelayM       equ 0x21           ; delay register MID byte
DelayH       equ 0x22           ; delay register HIGH byte
;
; -------------
; PROGRAM START
; -------------
;
             org 0h             ; startup address = 0000

             bsf Status,RP0     ; set RP0 for RAM page 1
             clrf TrisA         ; all PortA = outputs
             clrf TrisB         ; all PortB = outputs
             bcf Status,RP0     ; set RP0 for RAM page 0

start        bcf PortA,RELAY    ; turn on RELAY on RA0
             call Delay500      ; execute a 500mS delay

             bsf PortA,RELAY    ; turn off RELAY on RA0
             call Delay500      ; execute a 500mS delay

             btfss PIR1,RCIF    ; check for received PC character
             goto NoChar

             movf RCREG,w       ; Yes, clear receive buffer
             clrf PCLATH        ; exit run mode
             goto 0h            ; jump to start of PicNPro code

NoChar       goto start         ; do this loop forever
;
; --------------------------------
; SUBROUTINE: waste time for 500mS
; --------------------------------
;
Delay500     clrf DelayL        ; /R clear DelayL to 0
             clrf DelayM        ; clear DelayM to 0
             movlw 3h           ; set DelayH to 3
             movwf DelayH
Wait1        decfsz DelayL      ; subtract 1 from DelayL
             goto Wait1         ; if not 0, goto Wait1
             decfsz DelayM      ; subtract 1 from DelayM
             goto Wait1         ; if not 0, goto Wait1
             decfsz DelayH      ; subtract 1 from DelayH
             goto Wait1         ; if not 0, goto Wait1
             return             ; finished the delay

             end
