		Title  "PicNPoke 7 Segment Program A"

		list p=16f84 		; processor type
;
; This program is used to control a 7 segment display
; The display is connected to PortB
; The program energises each segment then repeats
;
PortB		equ 0x06		; PortB RAM address
TrisA		equ 0x85		; TRISA RAM address
TrisB		equ 0x86		; TRISB RAM address
Status		equ 0x03		; Status RAM address
Carry		equ 0x00		; Status Carry flag = bit 0
RP0		equ 0x05		; Status RP0 bit = bit 5
DelayL		equ 0x0C		; delay register LOW byte
DelayM		equ 0x0D		; delay register MID byte
DelayH		equ 0x0E		; delay register HIGH byte
Display		equ 0x0F		; display data
; 
; -------------
; PROGRAM START
; -------------
;
		org 0h			; startup address = 0000

		bsf Status,RP0		; set RP0 for RAM page 1
		clrf TrisA		; all PortA = outputs
		clrf TrisB		; all PortB = outputs
		bcf Status,RP0		; set RP0 for RAM page 0

Loop1		movlw 1h		; set Display value = 1
		movwf Display
Loop2		movf Display,w		; put Display into W register
		movwf PortB		; now send this value to PortB
		call Delay500		; execute a 500mS delay
		bcf Status,Carry
                rlf Display             ; shift Display value left
		btfss Status,Carry	; test carry bit		
		goto Loop2		; carry = 0, do Loop 2
		goto Loop1		; carry = 1, do Loop 1
;
; --------------------------------
; SUBROUTINE: waste time for 500mS
; --------------------------------
;
Delay500	clrf DelayL		; /R clear DelayL to 0
		clrf DelayM		; clear DelayM to 0
		movlw 3h		; set DelayH to 3
		movwf DelayH
Wait1		decfsz DelayL		; subtract 1 from DelayL
		goto Wait1		; if not 0, goto Wait1
		decfsz DelayM		; subtract 1 from DelayM
		goto Wait1		; if not 0, goto Wait1
		decfsz DelayH		; subtract 1 from DelayH
		goto Wait1		; if not 0, goto Wait1
		return			; finished the delay


		end
